package com.abcseo.ws2300.servlet;

import java.io.IOException;
import java.io.OutputStreamWriter;
import java.io.PrintWriter;
import java.util.Vector;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import com.abcseo.ws2300.Configuration;
import com.abcseo.ws2300.WSThread;

/**
 * 
 * @author David George
 * @author <a href="mailto:david.george@gmail.com">David George</a>
 * @version $Id: $
 *          <p>
 *          Copyright  2005 David George
 *          <p>
 *          This program is free software; you can redistribute it and/or modify
 *          it under the terms of the GNU General Public License as published by
 *          the Free Software Foundation; either version 2 of the License, or
 *          (at your option) any later version.
 *          <p>
 *          This program is distributed in the hope that it will be useful, but
 *          WITHOUT ANY WARRANTY; without even the implied warranty of
 *          MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 *          General Public License for more details.
 *          <p>
 *          You should have received a copy of the GNU General Public License
 *          along with this program; if not, write to the Free Software
 *          Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
 *          USA
 */
public class ShutdownServlet extends HttpServlet {
	static final long serialVersionUID = 0;

	public void doGet(HttpServletRequest request, HttpServletResponse response)
			throws IOException, ServletException {
		Configuration config = null;

		config = Configuration.getInstance();

		config.shutdown = true;

		PrintWriter out = null;
		try {
			out = new PrintWriter(new OutputStreamWriter(response
					.getOutputStream()));
		} catch (IllegalStateException e) {
			out = response.getWriter();
		}

		String referer = request.getHeader("referer");
		response.setContentType("text/html");

		out.write("<html><body>");
		out.write("<p>Shutting down OpenJ2300...</p>");
		Vector<WSThread> vt = config.getThreadList();
		
		for (int i = 0; i < vt.size(); i++) {
			WSThread t = vt.get(i);
			t.shutdown();
		}
		out.write("<p>OpenJ2300 shutdown</p>");
		out.write("</body></html>");
		out.flush();
		System.exit(0); // todo: this needs improving!
	}

}
